/* Copyright (C) 2005, 2006, 2007, 2008, 2009, 2010 Stefan Frenz
 * 
 * This file is part of SJC, the Small Java Compiler written by Stefan Frenz.
 * 
 * SJC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SJC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SJC. If not, see <http://www.gnu.org/licenses/>.
 */

package osio.sun;

import java.io.*;
import osio.TextReader;

/**
 * FileTextReader: read a file as text
 * 
 * @author S. Frenz
 * @version 100114 always creating a new data-array to enable valid source printing
 *  version 090303 adopted changed osio package structure
 *  version 090207 added copyright notice
 *  version 070331 moved system independent code to TextReader
 *  version 060711 changed to read everything at once
 *  version 060613 adapted to osio-interfaces
 *  version 060607 initial version
 */

public class FileTextReader extends TextReader {
  protected boolean systemReadData(String fname) {
    int len;
    InputStream is;
    try {
      is=new FileInputStream(fname);
      len=is.available();
      data=new byte[len];
      if (is.read(data, 0, len)!=len) return false;
      is.close();
    }
    catch (IOException e) {
      return false;
    }
    return true;
  }
}
